;;; srfi-40.scm
;;;
;;; Based on the original SRFI 40 reference implementation by Philip
;;; L. Bewig and Andre von Tonder, modified for Chicken by Category 5.
;;;
;;; 29 December 2003  catfive/chaosnet.org

;;; Copyright (C) 2003 by Philip L. Bewig of Saint Louis, Missouri,
;;; United States of America.  All rights reserved.

;; STREAM-LOW-LEVEL-LAZY -- an "atomic" (delay (force ...))
;;(define-syntax stream-low-level-lazy
;;  (syntax-rules ()
;;    ((stream-low-level-lazy exp)
;;        (cons 'suspension (lambda () exp)))))

; Use vector rather than box to avoid having to export box:

(define-macro stream-low-level-lazy
  (lambda (exp)
    `(vector (cons 'suspension (lambda () ,exp)))))

;; STREAM-LOW-LEVEL-DELAY -- make an expression into a low-level promise
;;(define-syntax stream-low-level-delay
;;  (syntax-rules ()
;;    ((stream-low-level-delay exp)
;;      (stream-low-level-lazy (stream-low-level-strict exp)))))

(define-macro stream-low-level-delay
  (lambda (exp)
    `(stream-low-level-lazy (stream-low-level-strict ,exp))))

;; STREAM-CONS object stream -- primitive constructor of streams
;;(define-syntax stream-cons
;;  (syntax-rules ()
;;    ((stream-cons obj strm)
;;      (make-stream
;;        (stream-low-level-delay
;;          (if (not (stream? strm))
;;              (stream-error "attempt to stream-cons onto non-stream")
;;              (cons obj strm)))))))
(define-macro stream-cons
  (lambda (obj strm)
    (let ((strm-val (gensym)))
      `(make-stream
         (stream-low-level-delay
           (let ((,strm-val ,strm))
             (if (not (stream? ,strm-val))
                 (stream-error "attempt to stream-cons onto non-stream")
                 (cons ,obj ,strm-val))))))))

;; STREAM-DELAY object -- the essential stream mechanism
;;(define-syntax stream-delay
;;  (syntax-rules ()
;;    ((stream-delay expr)
;;      (make-stream
;;        (stream-low-level-lazy expr)))))
(define-macro stream-delay
  (lambda (exp)
    `(make-stream (stream-low-level-lazy ,exp))))

;;; END


